/*
    PrintDialog.cpp

    NOTE: This file is a generated file.
          Do not modify it by hand!
*/

#include "wpch.hpp"
#include "PrintDialog.hpp"

// Code added here will be included at the top of the .CPP file

//  Include definitions for resources.
#include "WRes.h"
WForm *_CreatePrintDialog( void )
{
    extern WForm * __MainForm;
    PrintDialog * __form;

    __form = new PrintDialog;
    if( __form != NULL ) {
        if( __MainForm == NULL ) {
            __MainForm = __form;
        }
        if( !__form->Initialize() || !__form->Create() ) {
            delete __form;
            __form = NULL;
        }
    }
    return( __form );
}

void _DeletePrintDialog( WForm * __item )
{
    delete  __item;
}

__PrintDialog_Base::__PrintDialog_Base() : WDialog()
    , cb_1( NULL )
    , label_1( NULL )
{
    static WEventHandlerList  __BaseHandlers[] = {
        { WCreateEvent, (WEventHandler)&__PrintDialog_Base::__Base_Create },
        { WCloseEvent,  (WEventHandler)&__PrintDialog_Base::__Base_Close },
        { WDestroyEvent,(WEventHandler)&__PrintDialog_Base::__Base_Destroy },
        { WNullEvent,   (WEventHandler)NULL },
    };
    SetEventHandlerList( __BaseHandlers );

}

__PrintDialog_Base::~__PrintDialog_Base()
{
    Destroy();
}

WBool __PrintDialog_Base::Create( WWindow * __parent )
{
    WBool  __ok;

    __ok = WWindow::Create(  __parent, WResourceID("ID_PrintDialog") );
    return( __ok );
}

WBool __PrintDialog_Base::__Base_Create( WObject *, WCreateEventData * __event )
{
    WBool __createReturn = FALSE;
    Center();

    cb_1                  = new WCommandButton;
    label_1               = new WLabel;

    cb_1->Create( this, ID_cb_1 );
    label_1->Create( this, ID_label_1 );

    SetFont( WFont( "8.MS Sans Serif" ) );
    SetName( "PrintDialog" );
    cb_1->SetDefault( true );
    cb_1->SetPressed( false );
    cb_1->SetCancel( true );
    cb_1->SetName( "cb_1" );
    label_1->SetName( "label_1" );

    __Base_SetEventHandlers( TRUE );
    __createReturn = ((PrintDialog *) this)->PrintDialog_Create( this, __event );

    SetVisible( TRUE );
    return( __createReturn );
}

void __PrintDialog_Base::__Base_SetEventHandlers( WBool __add )
{
    static WEventHandlerList __PrintDialog_EventHandlers[] = {
        { WUserEvent, (WEventHandler)&PrintDialog::PrintDialog_User },
        { WNullEvent, NULL }
    };
    static WEventHandlerList __cb_1_EventHandlers[] = {
        { WClickEvent, (WEventHandler)&PrintDialog::cb_1_Click },
        { WNullEvent, NULL }
    };

    if( __add ) {
        SetEventHandlerList( __PrintDialog_EventHandlers, this );
        cb_1->SetEventHandlerList( __cb_1_EventHandlers, this );
    } else {
        SetEventHandlerList( __PrintDialog_EventHandlers, this );
        cb_1->RemoveEventHandlerList( __cb_1_EventHandlers, this );
    }
}

WBool __PrintDialog_Base::__Base_Close( WObject *, WEventData * )
{
    extern WForm * __MainForm;

    Destroy();
    if( (WForm*) this == __MainForm ) {
        WAppObject.Quit();
    }
    return( TRUE );
}

WBool __PrintDialog_Base::__Base_Destroy( WObject *, WEventData * __event  )
{
    WBool __destroyReturn = FALSE;

    #ifdef _DEBUG
        WMemory::FreeDeleteLog();
    #endif // _DEBUG
    __destroyReturn = ((PrintDialog *) this)->PrintDialog_Destroy( this, __event );

    __Base_SetEventHandlers( FALSE );
    delete cb_1;
    delete label_1;

    cb_1                  = NULL;
    label_1               = NULL;
    return( __destroyReturn );
}

WBool PrintDialog::PrintDialog_Create(
    WObject *               source,
    WCreateEventData *      event )
{
    _cancel = FALSE;
    
    _printer.Create( this, (WThreadRoutine) &PrintDialog::PrinterThread );
    
    if( !_printer.GetActive() ){
        PostUserEvent( this, 0 );
    }
    
    return FALSE;
}
WBool PrintDialog::PrintDialog_Destroy(
    WObject *           source,
    WEventData *        event )
{
    if( _printer.GetActive() ){
        _cancel = TRUE;
        _printer.Wait();
    }
    
    return FALSE;
}
WBool PrintDialog::PrintDialog_User(
    WObject *               source,
    WUserEventData *        event )
{
    if( event->data == 0 || !_printer.GetActive() ){
        label_1->SetText( "Done." );
        
        _cancel = TRUE;
        Dismiss( 0 );
    } else {
        WString caption;
        
        caption.Sprintf( "Printing page %d...", event->data );
        label_1->SetText( caption );
    }
    
    return FALSE;
}
PrintDialog::PrintDialog()
{
    
}
PrintDialog::~PrintDialog()
{
    
}
WDWord PrintDialog::PrinterThread( void * )
{
    WLong count = _strings.GetCount();
    
    _pageSize = _printerCanvas.GetSize();
    _lineHeight = _printerCanvas.GetFont().GetHeight();
    _pageNumber = 0;

    _printerCanvas.StartDocument();
    _inPage = FALSE;
    _pos.x = _pos.y = 0;
    
    for( int i = 0; i < count; ++i ){
        
        // Always check for a cancellation first...
        
        if( _cancel ) break;
        
        const WAnsiChar *text = _strings[i].GetText();
        WInt             wrap;
        
        wrap = _printerCanvas.CalculateWrapLength( _pageSize.w,
                                                   text );
        PrintLine( text, wrap );
        
        while( wrap != strlen( text ) ){
            text += wrap;
            wrap  = _printerCanvas.CalculateWrapLength( _pageSize.w,
                                                        text );
                                                        
            PrintLine( text, wrap );
        }                                                 
    }
    
    if( _cancel ){
        _printerCanvas.AbortDocument();
    } else {
        if( _inPage ){
            _printerCanvas.EndPage();
        }
        
        _printerCanvas.EndDocument();
    }
    
    // Signal we're done...
    
    PostUserEvent( this, 0 );
    
    return 0;
}
WBool PrintDialog::Create( WForm *owner, WPrinterCanvas & canvas,
                           WStringArray & arr )
{
    _printerCanvas = canvas;
    _strings       = arr;
    
    return __PrintDialog_Base::Create( owner );
}
WBool PrintDialog::Create()
{
    return FALSE;
}
WBool PrintDialog::PrintLine( const WAnsiChar *text, WInt numChars )
{
    if( _inPage && _pos.y > _pageSize.h - _lineHeight ){
        _inPage = FALSE;
        _printerCanvas.EndPage();
    }
        
    if( !_inPage ){
        _printerCanvas.StartPage();
        _inPage = TRUE;
        _pos.x = _pos.y = 0;
        
        WString str;
        
        str.Sprintf( "Page %d", ++_pageNumber );
        
        // Tell the dialog to update its caption... 
        // This is kind of silly, but it works....
        
        PostUserEvent( this, _pageNumber );
        
        _printerCanvas.DrawText( _pos, str );
        _pos.y += 2 * _lineHeight;
    }
    
    _printerCanvas.DrawText( _pos, text, numChars );
    
    _pos.y += _lineHeight;
    
    return TRUE;
}
WBool PrintDialog::cb_1_Click(
	WObject *   		source,
	WEventData *		event )
{
    PostUserEvent( this, 0 );
    return FALSE;
}
