/*
    TraceOptions.cpp

    NOTE: This file is a generated file.
          Do not modify it by hand!
*/

#include "wpch.hpp"
#include "TraceOptions.hpp"

// Code added here will be included at the top of the .CPP file

//  Include definitions for resources.
#include "WRes.h"

#define TRACE_OVERWRITE        0x01
#define TRACE_SUMMARY          0x02
#define TRACE_TRACE            0x04
#define TRACE_WALK             0x08
#define TRACE_STRINGS          0x10
#define TRACE_OBJECTS          0x20
#define TRACE_GDIHANDLES       0x40

WBool TraceOptionsFDXStruct::Save( WRegistryKey & key, const WString & value )
{
    WDWord  traceBits = 0;
    WString str;
    
    if( overwrite ) traceBits |= TRACE_OVERWRITE;
    if( summary ) traceBits |= TRACE_SUMMARY;
    if( trace ) traceBits |= TRACE_TRACE;
    if( walk ) traceBits |= TRACE_WALK;
    if( strings ) traceBits |= TRACE_STRINGS;
    if( objects ) traceBits |= TRACE_OBJECTS;
    if( gdihandles ) traceBits |= TRACE_GDIHANDLES;
    
    // Make a string out of it.  Why do this instead of 
    // saving the WDWord value out directly?  No real 
    // reason except that strings are easy to handle 
    // when editing or viewing the registry by hand...
    
    str.Sprintf( "%d", traceBits );
    
    return key.SetStringValue( value, str );
}

WBool TraceOptionsFDXStruct::Restore( WRegistryKey & key, const WString & value )
{
    WString str = key.GetStringValue( value );
    WDWord  traceBits = str.GetLong();
    
    #define ISON(x) ((traceBits&(x))!=0)
    
    overwrite = ISON( TRACE_OVERWRITE );
    summary = ISON( TRACE_SUMMARY );
    trace = ISON( TRACE_TRACE );
    walk = ISON( TRACE_WALK );
    strings = ISON( TRACE_STRINGS );
    objects = ISON( TRACE_OBJECTS );
    gdihandles = ISON( TRACE_GDIHANDLES );
    
    return TRUE;
}
WForm *_CreateTraceOptions( void )
{
    extern WForm * __MainForm;
    TraceOptions * __form;

    __form = new TraceOptions;
    if( __form != NULL ) {
        if( __MainForm == NULL ) {
            __MainForm = __form;
        }
        if( !__form->Initialize() || !__form->Create() ) {
            delete __form;
            __form = NULL;
        }
    }
    return( __form );
}

void _DeleteTraceOptions( WForm * __item )
{
    delete  __item;
}

__TraceOptions_Base::__TraceOptions_Base() : WDialog()
    , __FDXPointer( NULL )
    , groupb_1( NULL )
    , overwrite( NULL )
    , summary( NULL )
    , trace( NULL )
    , walk( NULL )
    , groupb_2( NULL )
    , strings( NULL )
    , objects( NULL )
    , gdihandles( NULL )
    , cancel( NULL )
    , ok( NULL )
{
    static WEventHandlerList  __BaseHandlers[] = {
        { WCreateEvent, (WEventHandler)&__TraceOptions_Base::__Base_Create },
        { WCloseEvent,  (WEventHandler)&__TraceOptions_Base::__Base_Close },
        { WDestroyEvent,(WEventHandler)&__TraceOptions_Base::__Base_Destroy },
        { WNullEvent,   (WEventHandler)NULL },
    };
    SetEventHandlerList( __BaseHandlers );

}

__TraceOptions_Base::~__TraceOptions_Base()
{
    Destroy();
}

WBool __TraceOptions_Base::Create( WWindow * __parent, TraceOptionsFDXStruct *__fdx )
{
    if( __fdx == NULL ) {
        if( __FDXPointer == NULL  ) {
            FDXGetDefault( &__FDXData );
            __fdx = &__FDXData;
        } else {
            __fdx = __FDXPointer;
        }
    }
    __FDXPointer = __fdx;

    WBool  __ok;

    __ok = WWindow::Create(  __parent, WResourceID("ID_TraceOptions") );
    return( __ok );
}
void __TraceOptions_Base::FDXGetDefault( TraceOptionsFDXStruct * __fdx )
{
        __fdx->overwrite =  false;
        __fdx->summary = false;
        __fdx->trace =   false;
        __fdx->walk =    false;
        __fdx->strings = false;
        __fdx->objects = false;
        __fdx->gdihandles =  false;
}

TraceOptionsFDXStruct * __TraceOptions_Base::FDXGetTarget()
{
    return( __FDXPointer );
}

void __TraceOptions_Base::FDXSetTarget( TraceOptionsFDXStruct * __fdx )
{
    __FDXPointer = __fdx;
}


WBool __TraceOptions_Base::__Base_Create( WObject *, WCreateEventData * __event )
{
    WBool __createReturn = FALSE;
    Center();

    groupb_1              = new WGroupBox;
    overwrite             = new WCheckBox;
    summary               = new WCheckBox;
    trace                 = new WCheckBox;
    walk                  = new WCheckBox;
    groupb_2              = new WGroupBox;
    strings               = new WCheckBox;
    objects               = new WCheckBox;
    gdihandles            = new WCheckBox;
    cancel                = new WCommandButton;
    ok                    = new WCommandButton;

    groupb_1->Create( this, ID_groupb_1 );
    overwrite->Create( this, ID_overwrite );
    summary->Create( this, ID_summary );
    trace->Create( this, ID_trace );
    walk->Create( this, ID_walk );
    groupb_2->Create( this, ID_groupb_2 );
    strings->Create( this, ID_strings );
    objects->Create( this, ID_objects );
    gdihandles->Create( this, ID_gdihandles );
    cancel->Create( this, ID_cancel );
    ok->Create( this, ID_ok );

    overwrite->SetFDXDataSource( &__FDXPointer->overwrite );
    summary->SetFDXDataSource( &__FDXPointer->summary );
    trace->SetFDXDataSource( &__FDXPointer->trace );
    walk->SetFDXDataSource( &__FDXPointer->walk );
    strings->SetFDXDataSource( &__FDXPointer->strings );
    objects->SetFDXDataSource( &__FDXPointer->objects );
    gdihandles->SetFDXDataSource( &__FDXPointer->gdihandles );

    FDXInitializeControls();

    SetFont( WFont( "8.MS Sans Serif" ) );
    SetName( "TraceOptions" );
    groupb_1->SetName( "groupb_1" );
    overwrite->SetAutoSize( true );
    overwrite->SetName( "overwrite" );
    summary->SetAutoSize( true );
    summary->SetName( "summary" );
    trace->SetAutoSize( true );
    trace->SetName( "trace" );
    walk->SetAutoSize( true );
    walk->SetName( "walk" );
    groupb_2->SetName( "groupb_2" );
    strings->SetAutoSize( true );
    strings->SetName( "strings" );
    objects->SetAutoSize( true );
    objects->SetName( "objects" );
    gdihandles->SetAutoSize( true );
    gdihandles->SetName( "gdihandles" );
    cancel->SetPressed( false );
    cancel->SetCancel( true );
    cancel->SetName( "cancel" );
    ok->SetDefault( true );
    ok->SetPressed( false );
    ok->SetName( "ok" );

    __Base_SetEventHandlers( TRUE );

    SetVisible( TRUE );
    return( __createReturn );
}

void __TraceOptions_Base::__Base_SetEventHandlers( WBool __add )
{
    static WEventHandlerList __cancel_EventHandlers[] = {
        { WClickEvent, (WEventHandler)&TraceOptions::cancel_Click },
        { WNullEvent, NULL }
    };
    static WEventHandlerList __ok_EventHandlers[] = {
        { WClickEvent, (WEventHandler)&TraceOptions::ok_Click },
        { WNullEvent, NULL }
    };

    if( __add ) {
        cancel->SetEventHandlerList( __cancel_EventHandlers, this );
        ok->SetEventHandlerList( __ok_EventHandlers, this );
    } else {
        cancel->RemoveEventHandlerList( __cancel_EventHandlers, this );
        ok->RemoveEventHandlerList( __ok_EventHandlers, this );
    }
}

WBool __TraceOptions_Base::__Base_Close( WObject *, WEventData * )
{
    extern WForm * __MainForm;

    Destroy();
    if( (WForm*) this == __MainForm ) {
        WAppObject.Quit();
    }
    return( TRUE );
}

WBool __TraceOptions_Base::__Base_Destroy( WObject *, WEventData * __event  )
{
    WBool __destroyReturn = FALSE;

    #ifdef _DEBUG
        WMemory::FreeDeleteLog();
    #endif // _DEBUG

    __Base_SetEventHandlers( FALSE );
    delete groupb_1;
    delete overwrite;
    delete summary;
    delete trace;
    delete walk;
    delete groupb_2;
    delete strings;
    delete objects;
    delete gdihandles;
    delete cancel;
    delete ok;

    groupb_1              = NULL;
    overwrite             = NULL;
    summary               = NULL;
    trace                 = NULL;
    walk                  = NULL;
    groupb_2              = NULL;
    strings               = NULL;
    objects               = NULL;
    gdihandles            = NULL;
    cancel                = NULL;
    ok                    = NULL;
    __FDXPointer = NULL;
    return( __destroyReturn );
}

TraceOptions::TraceOptions()
{
    
}
TraceOptions::~TraceOptions()
{
    
}
WBool TraceOptions::cancel_Click(
    WObject *           source,
    WEventData *        event )
{
    Dismiss( FALSE );
    
    return FALSE;
}
WBool TraceOptions::ok_Click(
	WObject *   		source,
	WEventData *		event )
{
    FDXUpdateControls();
    Dismiss( TRUE );
    
    return FALSE;
}
